/*

AFRAMES 0.0.0 November 10th 1998
http://www.intrafoundation.com

Written by Lewis A. Sellers, aka Min

*/
	
#include <malloc.h>
#include <stdio.h>
#include <dir.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>
#include <dos.h>
#include <math.h>
#include <bios.h>
#include <string.h>

#define FALSE (1==0)
#define TRUE  (1==1)

#define FAILURE 0
#define SUCCESS 1

typedef unsigned char byte;
typedef unsigned short int word;
typedef unsigned long dword;

//TGA
unsigned char canvas_tgaheader[18];
unsigned char tgaheader[18];
struct  {
	unsigned char CharacterIdentificationField;
	unsigned char ColorMapType;
	unsigned char ImageTypeCode; //always 2
	unsigned short int ColorMapOrigin;
	unsigned short int ColorMapLength;
	unsigned char ColorMapEntrySize; //we only do 24
	unsigned short int XOrigin;
	unsigned short int YOrigin;
	unsigned short int Width;
	unsigned short int Height;
	unsigned char ImagePixelSize; //24?
	unsigned char ImageDescriptorByte;
} tgah,canvas_tgah;
char CIF[256];
struct  {
	byte blue;
	byte green;
	byte red;
} *canvas, *image, *p, *bgr;
FILE *tga;

int arg_bilinear=FALSE, arg_trilinear=FALSE, arg_gray=FALSE;

int frames=1;
float alpha=1;


//prototypes
int getlines(void);


////////////////////////////////////////////////////////////////////////////
//
//helpme
void helpme(void)
{
	printf("This app averages all same size TGA files in a folder to produce a motion blur effect.\n\n");
	printf("The syntax of this command is:\n\n");
	printf("aframes [-?] [-bf] [-tf] [-gray]\n\n");

	printf("\n");
	printf("Lewis A. Sellers: writer and contract Multimedia Website Developer\n");
	printf("mailto:lsellers@usit.net (The Fourth Millennium Foundation)\n");
	printf("http://www.public.usit.net/lsellers/ & http://www.intrafoundation.com\n");
	printf("http://brain-of-pooh.tech-soft.com/users/critters/bios/sellers_lewis.html\n");
	printf("\n");
	printf("You can bug the living bejesus out of me live on ICQ @ 491461\n");
	printf("(If I don't get back to you within a month, I'm out of prozac in some dark corner somewhere screaming things quite unintelligable but -- most curiously -- thick with a sumerian accent.)\n");
	printf("\n");
	printf("'The comedy is over' -i pagliacci\n");
}



////////////////////////////////////////////////////////////////////////////
//
unsigned long unalloced(void)
{
#ifdef __DJGPP__
	return _go32_dpmi_remaining_virtual_memory();
#endif
	return 0;
}


////////////////////////////////////////////////////////////////////////////
//
//kjllkjm <-susy oct 30 '98
void info_tgaheader(char *name)
{
	//give us some info...
	printf(" ERROR file %s\n",name);

	printf("  CharacterIdentificationField %d\n",tgah.CharacterIdentificationField);
	printf("  ColorMapType %d\n",tgah.ColorMapType);
	printf("  ImageTypeCode %d\n",tgah.ImageTypeCode);
	if(tgah.ImageTypeCode!=2) {
		  printf("   **must be type 2 - unmapped RGB\n");
	}
	 printf("  ColorMapOrigin %d\n",tgah.ColorMapOrigin);
	 printf("  ColorMapLength %d\n",tgah.ColorMapLength);
	 printf("  ColorMapEntrySize %d\n",tgah.ColorMapEntrySize);
	 printf("  XOrigin %d\n",tgah.XOrigin);
	 printf("  YOrigin %d\n",tgah.YOrigin);
	 printf("  Width %d\n",tgah.Width);
	 printf("  Height %d\n",tgah.Height);
	 printf("  ImagePixelSize %d\n",tgah.ImagePixelSize);
	 if(tgah.ImagePixelSize!=24) {
		  printf("   **must be 24 - 24 bit RGB\n");
	 }
	 printf("  ImageDescriptorByte %d\n",tgah.ImageDescriptorByte);
	 if(tgah.ImageDescriptorByte!=32) {
		  printf("   lower left origin\n");
	}
	else {
		  printf("   upper left origin\n");
	}
	if(tgah.CharacterIdentificationField>0) {
		printf("  CharacterIdentificationField:\n");
		printf("   '%s'\n",&CIF);
	}
}


////////////////////////////////////////////////////////////////////////////
// tga header
int fread_tgaheader(char *name)
{
	char ok=TRUE;

	if (fread(tgaheader, 18, 1, tga) != 1) {
		ok=FALSE;
	}


	tgah.CharacterIdentificationField=tgaheader[0];
	tgah.ColorMapType=tgaheader[1];
	tgah.ImageTypeCode=tgaheader[2];

	tgah.ColorMapOrigin=(tgaheader[4]<<8) + tgaheader[3];
	tgah.ColorMapLength=(tgaheader[6]<<8) + tgaheader[5];
	tgah.ColorMapEntrySize=tgaheader[7];

	tgah.XOrigin=(tgaheader[9]<<8) + tgaheader[8];
	tgah.YOrigin=(tgaheader[11]<<8) + tgaheader[10];

	tgah.Width=(tgaheader[13]<<8) + tgaheader[12];
	tgah.Height=(tgaheader[15]<<8) + tgaheader[14];

	tgah.ImagePixelSize=tgaheader[16];
	tgah.ImageDescriptorByte=tgaheader[17];

	//
	if(tgah.CharacterIdentificationField!=2)
		fread(&CIF,tgah.CharacterIdentificationField,1,tga);

	//
	if(tgah.ImageTypeCode!=2) {
		ok=FALSE;
	 }
	 if(tgah.ImagePixelSize!=24) {
		ok=FALSE;
	 }

	//
	if(ok==FALSE)
		info_tgaheader(name);


	return(ok);
}


////////////////////////////////////////////////////////////////////////////
// tga header
int fwrite_tgaheader(char *name)
{
	char ok=TRUE;
	
	memset(tgaheader,0,18);

	tgaheader[2]=2;
	tgaheader[7]=24;

	tgaheader[13]=canvas_tgah.Width>>8;
	tgaheader[12]=canvas_tgah.Width&255;
	tgaheader[15]=canvas_tgah.Height>>8;
	tgaheader[14]=canvas_tgah.Height&255;

	tgaheader[16]=24;
	tgaheader[17]=32;

	fwrite(tgaheader, 18, 1, tga);

	return(ok);
}


////////////////////////////////////////////////////////////////////////////
//
int canvas_widthHeight()
{
	int done;
	struct ffblk dirlist;

	done=findfirst("*.TGA",&dirlist,0);
	if(!done) {
		tga=fopen(dirlist.ff_name,"rb");
		if(tga==NULL)
			return(FAILURE);
		else {
			fread_tgaheader(dirlist.ff_name);
			fclose(tga);

			canvas_tgah.Width=(tgaheader[13]<<8) + tgaheader[12];
			canvas_tgah.Height=(tgaheader[15]<<8) + tgaheader[14];

			return(SUCCESS);
		}
	}
}


////////////////////////////////////////////////////////////////////////////
//
int imageLoad(char *name)
{
	int x,y;

	//open the file.
	tga=fopen(name,"rb");
	if(tga==NULL)
		return(FAILURE);
	else {
		if(!fread_tgaheader(name)) return(FAILURE);
		
		if(tgah.Width!=canvas_tgah.Width) return(FAILURE);
		if(tgah.Height!=canvas_tgah.Height) return(FAILURE);

		p=image;
		if(tgah.ImageDescriptorByte==32) {
			for(y=0;y<canvas_tgah.Height;y++) {
				for(x=0;x<canvas_tgah.Width;x++) {
					fread(p,3,1,tga);
					p++;
				}
			}
		} else {
			//flipped
			printf(" FLIPPED! no code for this....");
		}

		fclose(tga);
		return(SUCCESS);
	}
}


////////////////////////////////////////////////////////////////////////////
//
int imageAverage()
{
	int x,y,i;
	float r,g,b;

	i=0;
	for(y=0;y<canvas_tgah.Height;y++) {
		for(x=0;x<canvas_tgah.Width;x++) {

			canvas[i].red=canvas[i].red+image[i].red*alpha;
			canvas[i].green=canvas[i].green+image[i].green*alpha;
			canvas[i].blue=canvas[i].blue+image[i].blue*alpha;

			i++;
		}
	}
}


////////////////////////////////////////////////////////////////////////////
//
// bilinear filter
int post_bilinearFilter()
{
	int x,y,i;

	i=0;
	for(y=0;y<canvas_tgah.Height;y++) {
		for(x=0;x<canvas_tgah.Width;x++) {

			canvas[i].red=(canvas[i].red+((canvas[i-canvas_tgah.Width].red+canvas[i+canvas_tgah.Width].red+canvas[i-1].red+canvas[i+1].red)>>2))>>1;
			canvas[i].green=(canvas[i].green+((canvas[i-canvas_tgah.Width].green+canvas[i+canvas_tgah.Width].green+canvas[i-1].green+canvas[i+1].green)>>2))>>1;
			canvas[i].blue=(canvas[i].blue+((canvas[i-canvas_tgah.Width].blue+canvas[i+canvas_tgah.Width].blue+canvas[i-1].blue+canvas[i+1].blue)>>2))>>1;

			i++;
		}
	}
}


// trilinear filter
int post_trilinearFilter()
{
	int x,y,i;

	i=0;
	for(y=0;y<canvas_tgah.Height;y++) {
		for(x=0;x<canvas_tgah.Width;x++) {

			canvas[i].red=(canvas[i].red+((canvas[i-canvas_tgah.Width].red+canvas[i+canvas_tgah.Width].red+canvas[i-1].red+canvas[i+1].red +canvas[i-canvas_tgah.Width-1].red+canvas[i-canvas_tgah.Width+1].red+canvas[i+canvas_tgah.Width-1].red+canvas[i+canvas_tgah.Width+1].red)>>3))>>1;
			canvas[i].green=(canvas[i].green+((canvas[i-canvas_tgah.Width].green+canvas[i+canvas_tgah.Width].green+canvas[i-1].green+canvas[i+1].green +canvas[i-canvas_tgah.Width-1].green+canvas[i-canvas_tgah.Width+1].green+canvas[i+canvas_tgah.Width-1].green+canvas[i+canvas_tgah.Width+1].green)>>3))>>1;
			canvas[i].blue=(canvas[i].blue+((canvas[i-canvas_tgah.Width].blue+canvas[i+canvas_tgah.Width].blue+canvas[i-1].blue+canvas[i+1].blue +canvas[i-canvas_tgah.Width-1].blue+canvas[i-canvas_tgah.Width+1].blue+canvas[i+canvas_tgah.Width-1].blue+canvas[i+canvas_tgah.Width+1].blue)>>3))>>1;

			i++;
		}
	}
}

// gray
int post_gray()
{
	int x,y,i;
	byte g;

	i=0;
	for(y=0;y<canvas_tgah.Height;y++) {
		for(x=0;x<canvas_tgah.Width;x++) {

			g=((canvas[i].red+canvas[i].green+canvas[i].blue)/3);

			canvas[i].red=g;
			canvas[i].green=g;
			canvas[i].blue=g;

			i++;
		}
	}
}


////////////////////////////////////////////////////////////////////////////
//
int canvasUnload(char *name)
{
	int x,y;

	tga=fopen(name,"wb");
	if(tga==NULL)
		return(FAILURE);
	else {
		fwrite_tgaheader(name);

		p=canvas;
		for(y=0;y<canvas_tgah.Height;y++) {
			for(x=0;x<canvas_tgah.Width;x++) {
				fwrite(p,3,1,tga);
				p++;
			}
		}

		fclose(tga);
		return(SUCCESS);
	}
}



////////////////////////////////////////////////////////////////////////////
//
void process(void)
{
	int no,done;
	struct ffblk dirlist;
	float totalAlpha;

	//
	frames=0;
	done=findfirst("*.TGA",&dirlist,0);
	while (done==0) {
		if( (strcmp(dirlist.ff_name,"AFRAMES.TGA")==0) ) {
			//printf("skip %s\n",dirlist.ff_name);
		}
		else {
			frames++;
		}
		done=findnext(&dirlist);
	}
	alpha=1.0/(float)frames;
	printf(" frames %d alpha %f\n",frames,alpha);
	

	//
	no=0;
	totalAlpha=0.0;
	done=findfirst("*.TGA",&dirlist,0);
	while (done==0) {
		if( (strcmp(dirlist.ff_name,"AFRAMES.TGA")==0) ) {
			//printf("skip %s\n",dirlist.ff_name);
		}
		else {
			no=no+1;
			printf("%4d %12s ",no,dirlist.ff_name);
			if(imageLoad(dirlist.ff_name)==FAILURE)
				printf("Skip! (FORMAT IS NOT THE SAME)\n");
			else {
				printf("loaded... ");
				imageAverage();
				printf("average... ");
			}
			totalAlpha+=alpha;
			printf("(%f)\n",totalAlpha);
		}
		done=findnext(&dirlist);
	}
	printf("\n%d files.\n\n",no);

	if(arg_bilinear) {
		post_bilinearFilter();
		printf(" bilinear filter... ");
	}
	if(arg_trilinear) {
		post_trilinearFilter();
		printf(" trilinear filter... ");
	}
	if(arg_gray) {
		post_gray();
		printf(" gray... ");
	}

	canvasUnload("aframes.tga");
	printf("\nAFRAMES.TGA created.\n");

}


////////////////////////////////////////////////////////////////////////////
//
int main(int argc,char *argv[])
{
	dword mem=0;
	int n;
	char munged=TRUE, help=FALSE;

	//introductions
	clrscr();
	mem=unalloced();
	printf("AFRAMES 0.0.0 rendering post-processing utility by Lewis A. Sellers III.\n");
	printf("Latest versions at news:news.povray.org or http://www.intrafoundation.com\n");
	printf("Last compiled %s %s. GNUC %s. %d lines of C code.\n",__DATE__,__TIME__,__VERSION__,getlines());
	printf("This application requires a DPMI client in real-DOS mode. %umb free.\n",mem/1048576);
	printf(" \n");


	//scan for command-line args
	if(argc<2) munged=FALSE;
	for(n=1;n<argc;n++) {
		if(strcmp(argv[n],"-?")==0) { help=TRUE; }

		if(strcmp(argv[n],"-bf")==0) { arg_bilinear=TRUE; munged=FALSE; }
		if(strcmp(argv[n],"-tf")==0) { arg_trilinear=TRUE; munged=FALSE; }
		if(strcmp(argv[n],"-gray")==0) { arg_gray=TRUE; munged=FALSE; }
	}
	if(munged) { helpme(); }


	//
	if(!help) {
		//do pre-processing allocations and data gathering....
		printf("++preprocessing - get width/height\n");
		canvas_widthHeight();
		printf(" canvas.tga is %d x %d. size of pixels structs %d bytes\n",canvas_tgah.Width,canvas_tgah.Height,sizeof(bgr));
		printf("\n");


		//mallocs
		printf("++allocations\n");
		canvas=(void *)malloc(canvas_tgah.Width*canvas_tgah.Height*sizeof(bgr));
		if(canvas==NULL) {
			printf(" canvas allocation failed (%u bytes remaining)\n",unalloced());
			exit(FAILURE);
		}
		printf(" canvas buffer allocated (@%p).\n",canvas);

		image=(void *)malloc(canvas_tgah.Width*canvas_tgah.Height*sizeof(bgr));
		if(image==NULL) {
			printf(" image allocation failed (%u bytes remaining)\n",unalloced());
			exit(FAILURE);
		}
		printf(" image buffer allocated (@%p).\n",image);
		printf("\n");


		//now, finally, the canvas processing
		printf("++processing\n");
		process();


		//frees
		free(image);
		free(canvas);
	}

	return(SUCCESS);
}


////////////////////////////////////////////////////////////////////////////
//
//cute trick of mine for single file programs
int getlines() { return __LINE__+1; }
